<!DOCTYPE html>
<html>
<head>
	<title>Cluster assignment</title>
	<link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css" integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="">
	<link rel="stylesheet" href="https://unpkg.com/leaflet@1.3.4/dist/leaflet.css" integrity="sha512-puBpdR0798OZvTTbP4A8Ix/l+A4dHDD0DGqYW6RQ+9jxkRFclaxxQb/SJAWZfWAkuyeQUytO7+7N4QKrDh+drA==" crossorigin=""/>
	<link rel="stylesheet" type="text/css" href="http://cdnjs.cloudflare.com/ajax/libs/leaflet.markercluster/1.4.1/MarkerCluster.css" />
    <link rel="stylesheet" type="text/css" href="http://cdnjs.cloudflare.com/ajax/libs/leaflet.markercluster/1.4.1/MarkerCluster.Default.css" />
   <style>
   	#mapid { height: 800px; width: 600px; }
   </style>
</head>
<body>
	<div class="container-fluid">
	  <div class="row">
		<div class="col-sm">
		  <div class="card">
		  <div class="card-header">
			<h5>Clustered Map</h5>
			<div class="input-group mb-3">
				<input type="text" class="form-control" id="data-url" aria-describedby="basic-addon3" placeholder="Paste geojson data url here" value="https://gist.githubusercontent.com/woutervh-/b9799584f2dc41141daddb5f7223d6a5/raw/bda38c3629bd431b3f4b88f48c6f35e78cfd5c6b/example%2520data-set.json
">
				<div class="input-group-append">
					<button type="button" id="renderData" class="btn btn-primary">Render Data</button>
				</div>
			</div>
		  </div>
		  <div class="card-body">
			<div id="mapid"></div>
		  </div>
		</div>
		</div>
		<div class="col-sm">
			<div class="card">
				<form>
					<h5 class="card-header">Configurations</h5>
					  <div class="card-body">
						<div class="card mb-3">
							<h6 class="card-header">Map dimensions</h6>
							<div class="card-body">
								<div class="form-group row">
									<div class="form-group col-md-6">
										<label for="mapWidth" class="col-form-label">Width</label>
										<input type="number" class="form-control" id="mapWidth" placeholder="Map width" value="600">
									</div>
									<div class="form-group col-md-6">
										<label for="mapHeight" class="col-form-label">Height</label>
										<input type="number" class="form-control" id="mapHeight" placeholder="Map height" value="800">
									</div>
								</div>
							</div>
						</div>
						<div class="card mb-3">
							<h6 class="card-header">Icon dimensions</h6>
							<div class="card-body">
								<div class="form-group row">
									<div class="form-group col-md-6">
										<label for="iconWidth" class="col-form-label">Width</label>
										<input type="number" class="form-control" id="iconWidth" placeholder="Icon width" value="20">
									</div>
									<div class="form-group col-md-6">
										<label for="iconHeight" class="col-form-label">Height</label>
										<input type="number" class="form-control" id="iconHeight" placeholder="Icon height" value="40">
									</div>
								</div>
							</div>
						</div>
						<div class="card mb-3">
							<h6 class="card-header">Map coordinate bounding box</h6>
							<div class="card-body">
								<div class="form-group row">
									<div class="form-group col-md-6">
										<label for="lowerLeftLatitude" class="col-form-label">Lower left latitude</label>
										<input type="text" class="form-control" id="lowerLeftLatitude" placeholder="Lower left latitude" value="51.4904">
									</div>
									<div class="form-group col-md-6">
										<label for="lowerLeftlongitude" class="col-form-label">Lower left longitude</label>
										<input type="text" class="form-control" id="lowerLeftlongitude" placeholder="Lower left longitude" value="-0.27603">
									</div>
								</div>
								<div class="form-group row">
									<div class="form-group col-md-6">
										<label for="topRightLatitude" class="col-form-label">Top right latitude</label>
										<input type="text" class="form-control" id="topRightLatitude" placeholder="Top right latitude" value="51.6836">
									</div>
									<div class="form-group col-md-6">
										<label for="topRightlongitude" class="col-form-label">Top right longitude</label>
										<input type="text" class="form-control" id="topRightlongitude" placeholder="Top right longitude" value="0.05081">
									</div>
								</div>
							</div>
						</div>
					  </div>
					<div class="card-footer text-right">
						<button id="mapReload" type="button" class="btn btn-primary">Reload Map</button>
					</div>
				</form>
			</div>
		</div>
		<div class="col-sm">
			<div class="card">
			  <div class="card-header">
				<h5>Description</h5>
			  </div>
			  <div class="card-body">
				<p>
					This is an application to demonstrate clustering large amount of data points on the map.
					In case there are more than one nearby points within a proximity of 100px (customizable), a cluster is formed.
					This way the data points do not appear overlapped over each other and provides better visualisation.
					Zooming in or clicking a cluster, explodes the cluster into sub-clusters (in case there still exist multiple nearby markers) or displays the actual data point.
					For data points that are too close to each other even after a maximum zoom, clicking the cluster would display the contained data points.
				</p>
				<p>
					<ul>
						<li>An input field is provided for the end user to enter any geojson data source location.</li>
						<li>As per the requirement, the map dimensions, icon dimensions and the map coordinate bounding box parameters are made available for user to specify.</li>	
					</ul>
				</p>
					In order to implement clustering of markers, the Leaflet Marker Cluster plugin of the open source Leaflet JavaScript library has been used.
					This library provides following features:
					<ul>
						<li>It is easy to integrate</li>
						<li>Easy to customize (e.g. can customize cluster marker icon and individual markers)</li>
						<li>Groups overlapping or nearby markers into a cluster</li>
						<li>Supports mobile and desktop platforms</li>
						<li>Supports all browsers</li>
						<li>Has sub-plugins for additional functionalities e.g. to display child elements in a list when a cluster is clicked.</li>
					</ul>
				</p>
			  </div>
			</div>
		</div>
	  </div>
	</div>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.3.1/jquery.min.js"></script>
	<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.3/umd/popper.min.js" integrity="sha384-ZMP7rVo3mIykV+2+9J3UJ46jBk0WLaUAdn689aCwoqbBJiSnjAK/l8WvCWPIPm49" crossorigin=""></script>
	<script src="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/js/bootstrap.min.js" integrity="sha384-ChfqqxuZUCnJSK3+MXmPNIyE6ZbWh2IMqE241rYiqJxyMiZ6OW/JmZQ5stwEULTy" crossorigin=""></script>
    <script src="https://unpkg.com/leaflet@1.3.4/dist/leaflet.js" integrity="sha512-nMMmRyTVoLYqjP9hrbed9S+FzjZHW5gY1TWCHA5ckwXZBadntCNs8kEqAWdrb9O7rxbCaA4lKTIWjDXZxflOcA==" crossorigin=""></script>
    <script type='text/javascript' src='http://cdnjs.cloudflare.com/ajax/libs/leaflet.markercluster/1.4.1/leaflet.markercluster.js'></script>
    <script type='text/javascript' src='js/cluster.assignment.js'></script>	
</body>
</html>